import org.xml.sax.helpers.DefaultHandler;
//import java.util.Hashtable;
import java.util.Vector;
import java.util.HashSet;
import java.lang.String;
import org.xml.sax.*;
import java.io.*;
import java.util.*;

public class Parser extends DefaultHandler {

	private static HashSet whatCounts;
	private static Vector currAuthors;
	private static BufferedWriter edgefile;
	private static BufferedWriter nodefile;
	private static boolean needToRecord;
	private static String author; 
	private static int numPub;
	private static boolean isdb;
	private static boolean injournal;
	private static boolean inbooktitle;
	private static boolean inauthor;
	private static boolean inyear;
	private static boolean inpage;
	private static HashSet journalsCounts;
	private static HashSet conferenceCounts;
	private static String currJournalConference;
	private static String currYear;
	private static String fromPage;
	private static String toPage;
	public Parser(String nfilename, String efilename) {
		// TODO Auto-generated constructor stub
		super();
		currAuthors=new Vector();
		needToRecord=false;
		numPub=0;
		isdb=false;
		injournal=false;
		inbooktitle=false;
		inauthor=false;
		inyear=false;	
		whatCounts=new HashSet();
		whatCounts.add("article");
		whatCounts.add("inproceedings");
		//whatCounts.add("book");
		//whatCounts.add("proceedings");
		//whatCounts.add("incollection");
		//whatCounts.add("phdthesis");
		//whatCounts.add("masterthesis");
		//whatCounts.add("www");
		
		journalsCounts=new HashSet();
		conferenceCounts=new HashSet();
		
		//--------------------------------------------------
		// DB CORE
		journalsCounts.add("VLDB J.");
		journalsCounts.add("ACM Trans. Database Syst.");
		
		conferenceCounts.add("KDD");
		conferenceCounts.add("PODS");
		conferenceCounts.add("VLDB");
		conferenceCounts.add("SIGMOD Conference");
		//--------------------------------------------------
		
		try{
			nodefile=new BufferedWriter(new FileWriter(nfilename, false), 1024);
			edgefile=new BufferedWriter(new FileWriter(efilename, false), 1024);
		}catch(Exception e)
		{
			e.printStackTrace();
			System.exit(-1);
		}
	}
	protected void finalize() throws Throwable
	{
		
	}
	public void endElement(String uri, String local, String qName)
	throws SAXException
	{
		if(whatCounts.contains(local) && isdb)
		{
			numPub++;
			if(fromPage==null || fromPage.equals(""))
				fromPage="\\N";
			if(toPage==null || toPage.equals(""))
                                toPage="\\N";		
	
			for(int i=0; i<currAuthors.size(); i++)
			{
				try
				{
					nodefile.write((String)currAuthors.elementAt(i));
					nodefile.write("\t");
					nodefile.write(currJournalConference);
					nodefile.write("\t");
                                        nodefile.write(currYear);
					nodefile.write("\t");
                                        nodefile.write(fromPage);
					nodefile.write("\t");
                                        nodefile.write(toPage);
					//System.out.print("--");
					//System.out.println(new String(ch, start, length));
					nodefile.write("\n");
				}catch(IOException e)
				{
					e.printStackTrace();
					System.exit(-1);
				}
			}
			
			for(int i=0; i<currAuthors.size()-1; i++)
				for(int j=i+1; j<currAuthors.size(); j++)
				{
					try
					{
						String name1=(String)currAuthors.elementAt(i);
						String name2=(String)currAuthors.elementAt(j);
						if(name1.compareTo(name2)>0)
						{
							name1=(String)currAuthors.elementAt(j);
							name2=(String)currAuthors.elementAt(i);
							//System.out.println(name1+"\t"+name2);
						}
						edgefile.write(name1);
						edgefile.write("\t");
						edgefile.write(name2);
						edgefile.write("\t");
						edgefile.write(currJournalConference);
						edgefile.write("\t");
                                                edgefile.write(currYear);
						edgefile.write("\t");
                                                edgefile.write(fromPage);
						edgefile.write("\t");
                                                edgefile.write(toPage);
						edgefile.write("\n");
					}catch(IOException e)
					{
						e.printStackTrace();
						System.exit(-1);
					}
				}
		}else if(local.equals("author"))
		{
			currAuthors.add(author);
			
			needToRecord=false;
			inauthor=false;
		}else if(local.equals("journal"))
		{
			injournal=false;
		}else if(local.equals("booktitle"))
		{
			inbooktitle=false;
		}
		else if(local.equals("year"))
                {
                        inyear=false;
                }
		else if(local.equals("pages"))
		{
			inpage=false;
			if(fromPage!=null && !fromPage.equals(""))
			{
				//System.out.println(fromPage);
				fromPage.replace("C", "");
				fromPage.replace("C-", "");
				fromPage.replace("V", "");
                                fromPage.replace("V-", "");
				//fromPage.replace("a", "");
                                //fromPage.replace("b", "");
				if(fromPage.contains("v"))
					System.out.println(fromPage);
				int i=fromPage.indexOf('-');
                                int j=fromPage.lastIndexOf('-');
				if(!(fromPage.charAt(0)>='0'&& fromPage.charAt(0)<='9'))
				{
					fromPage=new String("");
				}
				else if(i==-1 || i==fromPage.length()-1)
				{
					fromPage=new String("");
				}else
				{
					toPage=fromPage.substring(j+1);
					fromPage=fromPage.substring(0, i);
					if(!fromPage.matches("[0-9]+"))
					{
						fromPage=new String("");
						toPage=new String("");
					}else if(!toPage.matches("[0-9]+"))
					{
						fromPage=new String("");
                                                toPage=new String("");
					}
				}
			}
		}

	}
	public void startElement(String uri, String local, String qName, Attributes attrs) 
	throws SAXException
	{
		if(whatCounts.contains(local))
		{
			currAuthors.clear();
			//currJournalConference=new String("");
			//currYear=new String("");
			fromPage=new String("");
			toPage=new String("");
			isdb=false;
			injournal=false;
			inbooktitle=false;
			inauthor=false;
			inyear=false;
			inpage=false;
		}else if(local.equals("author"))
		{
			needToRecord=true;
			author=new String("");
			inauthor=true;
		}else if(local.equals("journal"))
		{
			currJournalConference=new String("");
			injournal=true;
		}else if(local.equals("booktitle"))
		{
			currJournalConference=new String("");
			inbooktitle=true;
		}else if(local.equals("year"))
		{
			currYear=new String("");
			inyear=true;
		}else if(local.equals("pages"))
		{
			fromPage=new String("");
			toPage=new String("");
			inpage=true;
		}
	}
	public void endDocument() 
	throws SAXException
	{
		try
		{
			edgefile.close();
			nodefile.close();
		}catch(IOException e)
		{
			e.printStackTrace();
			System.exit(-1);
		}
		System.out.print("Number of Publications: ");
		System.out.println(numPub);
	}
	public void characters(char[] ch, int start, int length)
    throws SAXException
    {
		if(inauthor && needToRecord)
		{
			author=author+new String (ch, start, length);
		}else if(injournal)
		{
			currJournalConference=currJournalConference+new String (ch, start, length);
			//currJournalConference=journal;
			if(journalsCounts.contains(currJournalConference))
			{
				isdb=true;
				//System.out.println(currJournalConference);
			}
		}else if(inbooktitle)
		{
			currJournalConference=currJournalConference+new String (ch, start, length);
			//if(conferenceCounts.contains(booktitle))
			//{	
				isdb=true;
		//		System.out.println(booktitle);
			//}
		}else if(inyear)
		{
			currYear=currYear+new String (ch, start, length);
				isdb=true;
		}else if(inpage)
		{
			fromPage=fromPage+new String (ch, start, length);
				isdb=true;
		}
    }
}
